Bug 1495409 (CVE-2017-14491) - CVE-2017-14491 dnsmasq: heap overflow in the code responsible for building DNS replies
Summary: CVE-2017-14491 dnsmasq: heap overflow in the code responsible for building DN...
Keywords:
Status: CLOSED ERRATA
Alias: CVE-2017-14491
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
urgent
urgent
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard: impact=critical,public=20171002,repor...
Depends On: 1495516 1495517 1496264 1496265 1496277 1496278 1496310 1496311 1496312 1496313 1496314 1496315 1496316 1497691
Blocks: 1495418 1496355
TreeView+ depends on / blocked
 
Reported: 2017-09-26 01:42 UTC by Fabio Olive Leite
Modified: 2019-06-08 22:22 UTC (History)
24 users (show)

Fixed In Version: dnsmasq 2.78
Doc Type: If docs needed, set a value
Doc Text:
A heap buffer overflow was found in dnsmasq in the code responsible for building DNS replies. An attacker could send crafted DNS packets to dnsmasq which would cause it to crash or, potentially, execute arbitrary code.
Clone Of:
Environment:
Last Closed: 2017-10-02 18:15:40 UTC


Attachments (Terms of Use)
Upstream commit (7.78 KB, patch)
2017-09-26 10:46 UTC, Tomas Hoger
no flags Details | Diff
Follow-up patch from upstream (1.62 KB, patch)
2017-09-26 22:24 UTC, Tomas Hoger
no flags Details | Diff


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2017:2836 normal SHIPPED_LIVE Critical: dnsmasq security update 2017-10-02 21:18:46 UTC
Red Hat Product Errata RHSA-2017:2837 normal SHIPPED_LIVE Critical: dnsmasq security update 2017-10-02 20:19:55 UTC
Red Hat Product Errata RHSA-2017:2838 normal SHIPPED_LIVE Critical: dnsmasq security update 2017-10-02 20:23:56 UTC
Red Hat Product Errata RHSA-2017:2839 normal SHIPPED_LIVE Critical: dnsmasq security update 2017-10-02 21:07:36 UTC
Red Hat Product Errata RHSA-2017:2840 normal SHIPPED_LIVE Critical: dnsmasq security update 2017-10-02 19:20:16 UTC
Red Hat Product Errata RHSA-2017:2841 normal SHIPPED_LIVE Critical: dnsmasq security update 2017-10-02 19:53:55 UTC

Description Fabio Olive Leite 2017-09-26 01:42:21 UTC
Red Hat Product Security has been made aware of a heap-based buffer overflow affecting the DNS implementation of dnsmasq.

Comment 3 Doran Moppert 2017-09-26 05:10:32 UTC
Acknowledgments:

Name: Felix Wilhelm (Google Security Team), Fermin J. Serna (Google Security Team), Gabriel Campana (Google Security Team), Kevin Hamacher (Google Security Team), Ron Bowes (Google Security Team)

Comment 4 Tomas Hoger 2017-09-26 08:46:50 UTC
Further details from the 2.78 pre-release CHANGELOG:

    Fix heap overflow in DNS code. This is a potentially serious
    security hole. It allows an attacker who can make DNS
    requests to dnsmasq, and who controls the contents of
    a domain, which is thereby queried, to overflow
    (by 2 bytes) a heap buffer and either crash, or
    even take control of, dnsmasq.
    CVE-2017-14491 applies.
    Credit to Felix Wilhelm, Fermin J. Serna, Gabriel Campana
    and Kevin Hamacher of the Google Security Team for
    finding this.

Comment 8 Tomas Hoger 2017-09-26 10:46:30 UTC
Created attachment 1330989 [details]
Upstream commit

Comment 13 Tomas Hoger 2017-09-26 22:24:39 UTC
Created attachment 1331241 [details]
Follow-up patch from upstream

This corrects issues in the original patch as noted in comment 8.

Comment 19 Adam Mariš 2017-10-02 13:19:36 UTC
Created dnsmasq tracking bugs for this issue:

Affects: fedora-all [bug 1497691]

Comment 22 errata-xmlrpc 2017-10-02 15:20:52 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 5 Extended Lifecycle Support

Via RHSA-2017:2840 https://access.redhat.com/errata/RHSA-2017:2840

Comment 23 errata-xmlrpc 2017-10-02 15:54:25 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 5.9 Long Life

Via RHSA-2017:2841 https://access.redhat.com/errata/RHSA-2017:2841

Comment 24 errata-xmlrpc 2017-10-02 16:23:13 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7.2 Extended Update Support
  Red Hat Enterprise Linux 7.3 Extended Update Support

Via RHSA-2017:2837 https://access.redhat.com/errata/RHSA-2017:2837

Comment 25 errata-xmlrpc 2017-10-02 16:24:37 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 6

Via RHSA-2017:2838 https://access.redhat.com/errata/RHSA-2017:2838

Comment 26 errata-xmlrpc 2017-10-02 17:09:08 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 6.4 Advanced Update Support
  Red Hat Enterprise Linux 6.5 Advanced Update Support
  Red Hat Enterprise Linux 6.5 Telco Extended Update Support
  Red Hat Enterprise Linux 6.6 Advanced Update Support
  Red Hat Enterprise Linux 6.6 Telco Extended Update Support
  Red Hat Enterprise Linux 6.7 Extended Update Support
  Red Hat Enterprise Linux 6.2 Advanced Update Support

Via RHSA-2017:2839 https://access.redhat.com/errata/RHSA-2017:2839

Comment 27 errata-xmlrpc 2017-10-02 17:20:14 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7

Via RHSA-2017:2836 https://access.redhat.com/errata/RHSA-2017:2836

Comment 28 Garth Mollett 2017-10-02 21:43:01 UTC
Statement:

Red Hat OpenStack Platform includes the dnsmasq-utils RPM which does not contain this flaw's affected code-paths; Red Hat OpenStack Platform is therefore listed as not affected.

However, because all versions of Red Hat OpenStack Platform are based on Red Hat Enterprise Linux, all Red Hat OpenStack Platform users should absolutely upgrade the dnsmasq RPM from Red Hat Enterprise Linux as a matter of urgency using standard update mechanisms (such as 'yum update' or 'openstack overcloud update').


Note You need to log in before you can comment on or make changes to this bug.